package sample.hw_android_sdk_v100;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.PendingIntent;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.hardware.usb.UsbConstants;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbEndpoint;
import android.hardware.usb.UsbInterface;
import android.hardware.usb.UsbManager;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.SpinnerAdapter;

import java.util.HashMap;
import java.util.Iterator;
import java.util.regex.Pattern;


public class ImagePrintActivity extends Activity implements OnItemSelectedListener {

	private static final String TAG = "image file printing";

    private UsbManager mUsbManager;
    private UsbDevice mDevice;
    private UsbDeviceConnection mConnection;
    private UsbEndpoint mEndpointBulk;	
	// Intent
	private PendingIntent mPermissionIntent;
    private static final String ACTION_USB_PERMISSIONx = "com.android.example.USB_PERMISSION";
    // hwasung vendor id string
    private static final String HWASUNG_VENDOR_ID = "6";
     
    // printer commands
    private static final byte CMD_DLE = 0x10;
    private static final byte CMD_ESC = 0x1b;
    private static final byte CMD_GS = 0x1d;
    private static final byte CMD_FS = 0x1c;
    private static final byte CMD_SUB = 0x1a;
    private static final int MAX_IMAGE_LINE = 64;	// NOTE! do not edit!

    
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.image_print);
		
		Spinner mSpinner1 = (Spinner)findViewById(R.id.spinner1_item);	
		SpinnerAdapter ad = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, new String[] {"Sample1","Sample2","Sample3","Sample4","Sample5"});
		mSpinner1.setAdapter(ad);
		mSpinner1.setOnItemSelectedListener(this);
	
	}

	public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
		
		ImageView mImageView;
		Bitmap bm;

		mImageView = (ImageView) findViewById(R.id.imageView);
		
		switch(arg2)
		{
		case 0:
			bm = BitmapFactory.decodeFile("/sdcard/hw_image/bicycle.bmp");
			mImageView.setImageBitmap(bm);
			break;
		case 1:
			bm = BitmapFactory.decodeFile("/sdcard/hw_image/card.png");
			mImageView.setImageBitmap(bm);
			break;
		case 2:
			bm = BitmapFactory.decodeFile("/sdcard/hw_image/namdaemoon.gif");
			mImageView.setImageBitmap(bm);
			break;
		case 3:
			bm = BitmapFactory.decodeFile("/sdcard/hw_image/pizza.png");
			mImageView.setImageBitmap(bm);
			break;
		case 4:
			bm = BitmapFactory.decodeFile("/sdcard/hw_image/graylogo.bmp");
			mImageView.setImageBitmap(bm);
			break;
		}
	}	
	
	
	public void onNothingSelected(AdapterView<?> arg0) {
		// none process
	}

/*
 * *********************************************************************************
 *  Note! Do not edit the MAX_IMAGE_LINE = 192
 *  You can edit this Method for image file printing.
 *
 * *********************************************************************************
 */   
	
	// print Button
	public void onClick_image_print1( View v) {
		
    	char device_cnt;
    	int[] mIntBuf,mIntBuf2;
    	int i,j,k,byteOffset,bitToByte;
    	int mDataCnt,byteWidth,prnLine;
    	Bitmap bm;
    	
   		String Title;
   		String Message;

   		// set Hwasung System usb device 
        device_cnt = setDevice();
        
        // hwasung usb device is none or unconnected
        if( device_cnt == 0 ) return;

   		mIntBuf2 = new int[128];
   		int bmWidth,bmHeight,x,y;
		int[] mPixels;
  		byte rest = 0;	// multiple of 8? 
  		int blockCnt;	// row data block counter

		bm = BitmapFactory.decodeFile("/sdcard/hw_image/bicycle.bmp");
        bm = BitmapUtil.toGrayscale(bm, bm.getWidth(), bm.getHeight());
        bm = BitmapUtil.toOneBit(bm);

  		Spinner mSpinner1 = (Spinner)findViewById(R.id.spinner1_item);
		
		switch (mSpinner1.getSelectedItemPosition()){
			case 0:
				bm = BitmapFactory.decodeFile("/sdcard/hw_image/bicycle.bmp");
				break;
			case 1:
				bm = BitmapFactory.decodeFile("/sdcard/hw_image/card.png");
				break;
			case 2:
				bm = BitmapFactory.decodeFile("/sdcard/hw_image/namdaemoon.bmp");
				break;
			case 3:
				bm = BitmapFactory.decodeFile("/sdcard/hw_image/pizza.png");
				break;
			case 4:
				bm = BitmapFactory.decodeFile("/sdcard/hw_image/graylogo.bmp");
				break;
		}
 		
		// get image data height
		bmHeight = bm.getHeight();
		// get image data width
  		bmWidth = bm.getWidth();
  		byteWidth = bmWidth / 8;
  		i = bmWidth % 8;
   		if (i > 0) { byteWidth = byteWidth + 1; rest = 1; }	// none multiple of 8
   		


   		// lower the print speed for smooth printing
		// print speed command 3byte
   		mIntBuf2[0] = CMD_SUB;
		mIntBuf2[1] = 's';
		mIntBuf2[2] = 0x07;
		sendCommand(mDevice,mIntBuf2,3);
		mIntBuf = new int[2];


   		x = y = 0;
		mPixels = new int[bmWidth*MAX_IMAGE_LINE];		// max prnLine = 192
		mIntBuf = new int[(byteWidth*MAX_IMAGE_LINE)];
  		blockCnt = (bmHeight / MAX_IMAGE_LINE) ;
  		if((bmHeight % MAX_IMAGE_LINE) > 0 ) blockCnt += 1;
  		
  		for( k=0;k<blockCnt;k++){
  			if(bmHeight >= MAX_IMAGE_LINE){
 	  			prnLine = MAX_IMAGE_LINE;
 				bmHeight = bmHeight - prnLine;
  			}
  			else{
  	  			prnLine = bmHeight;
  			}

  			// get pixel color data
  			bm.getPixels(mPixels, 0, bmWidth, x, y, bmWidth, prnLine);
 				
  			j = 0;
  			bitToByte = 0;
  			int bit_p = 0;

  			for(i=0;i<(bmWidth*prnLine);i++){
  				switch( bit_p % 8){
  					case 0:
  		  				if( mPixels[i] == 0xff000000) {bitToByte |= 0x80; }	// black
  		  				if( mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff ) {
  		  					Title = "image data error(bit7)";
  		  					Message = "pixel value:"+ Integer.toString(mPixels[i]) ;
  		  					showDialog( Title, Message);
  		  					return;
  		  				}
  		  				break;
  					case 1:
  		  				if( mPixels[i] == 0xff000000) {bitToByte |= 0x40; }	// black
  		  				if( mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff ) {
  		  					Title = "image data error(bit6)";
  		  					Message = "pixel value:"+ Integer.toString(mPixels[i]) ;
  		  					showDialog( Title, Message);
  		  					return;
  		  				}
  		  				break;
  					case 2:
  		  				if( mPixels[i] == 0xff000000) {bitToByte |= 0x20; }	// black
  		  				if( mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff ) {
  		  					Title = "image data error(bit5)";
  		  					Message = "pixel value:"+ Integer.toString(mPixels[i]) ;
  		  					showDialog( Title, Message);
  		  					return;
  		  				}
  		  				break;
  					case 3:
  		  				if( mPixels[i] == 0xff000000) {bitToByte |= 0x10; }	// black
  		  				if( mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff ) {
  		  					Title = "image data error(bit4)";
  		  					Message = "pixel value:"+ Integer.toString(mPixels[i]) ;
  		  					showDialog( Title, Message);
  		  					return;
  		  				}
  		  				break;
  					case 4:
  		  				if( mPixels[i] == 0xff000000) {bitToByte |= 0x08; }	// black
  		  				if( mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff ) {
  		  					Title = "image data error(bit3)";
  		  					Message = "pixel value:"+ Integer.toString(mPixels[i]) ;
  		  					showDialog( Title, Message);
  		  					return;
  		  				}
  		  				break;
  					case 5:
  		  				if( mPixels[i] == 0xff000000) {bitToByte |= 0x04; }	// black
  		  				if( mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff ) {
  		  					Title = "image data error(bit2)";
  		  					Message = "pixel value:"+ Integer.toString(mPixels[i]);
  		  					showDialog( Title, Message);
  		  					return;
  		  				}
  		  				break;
  					case 6:
  		  				if( mPixels[i] == 0xff000000) {bitToByte |= 0x02; }	// black
  		  				if( mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff ) {
  		  					Title = "image data error(bit1)";
  		  					Message = "pixel value:"+ Integer.toString(mPixels[i]) ;
  		  					showDialog( Title, Message);
  		  					return;
  		  				}

  		  				break;
  					case 7:
  		  				if( mPixels[i] == 0xff000000) {bitToByte |= 0x01; }	// black
  		  				if( mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff ) {
  		  					Title = "image data error(bit0)";
  		  					Message = "pixel value:"+ Integer.toString(mPixels[i]) ;
  		  					showDialog( Title, Message);
  		  					return;
  		  				}

  		  				break;
  				}
  				
  				if( (bit_p % 8) == 7 ){
  				mIntBuf[j] = bitToByte;
  					bitToByte = 0;
  					j++;  
  				}

  				bit_p++;
  				
  				// last dot each line
  				if( ( i % bmWidth) == (bmWidth-1) ){
  					if(rest == 1) {		// if none multiple of 8, last byte
  	 					mIntBuf[j] =  bitToByte;
  	 					bitToByte = 0;
  	 					bit_p = 0;
  	 					j++;
  					}
  				}

  			}	// i end
  			
			// send raster bitimage command 8byte
			mIntBuf2[0] = CMD_GS;
			mIntBuf2[1] = 'v';
			mIntBuf2[2] = '0';
			mIntBuf2[3] = 0x00;				// size normal
			mIntBuf2[4] = byteWidth % 256;	// xL(LSB horizental number of data)
			mIntBuf2[5] = byteWidth / 256;	// xH(MSB horizental number of data)
			mIntBuf2[6] = prnLine % 256;	// yL(LSB vertical number of line)
			mIntBuf2[7] = prnLine / 256;	// yH(MSB vertical number of line)
			Log.d("IMG_TEST","xl : "+mIntBuf2[4]+" xH : " + mIntBuf2[5]+ " yL : "+mIntBuf2[6]+" yH : " +mIntBuf2[7]);

			sendCommand(mDevice,mIntBuf2,8);
			
			mDataCnt = byteWidth * prnLine;
			sendCommand(mDevice,mIntBuf,mDataCnt);
			y += prnLine;
  		}	// k end
		mIntBuf = new int[2];

		mIntBuf[0] = CMD_ESC;
		mIntBuf[1] = 0x0c;

		mDataCnt = 2;
		// call send data
		sendCommand(mDevice, mIntBuf, mDataCnt);

		mIntBuf = new int[2];

		mIntBuf[0] = CMD_ESC;
		mIntBuf[1] = 'S';
		mDataCnt = 2;
		// call send data
		sendCommand(mDevice, mIntBuf, mDataCnt);
   		// set the default print speed
		// print speed command 3byte
   		mIntBuf2[0] = CMD_SUB;
		mIntBuf2[1] = 's';
		mIntBuf2[2] = 14;
		sendCommand(mDevice,mIntBuf2,3);
 		
	}

/*
 * *********************************************************************************
 *  Note!
 *  Do not edit this Method.
 *  You should only use call this Method.
 *
 * *********************************************************************************
 */   
    private char setDevice() {
	    
 		String Title;
 		String Message;
 		String mDeviceNameStr;
 		UsbDevice mDeviceName;
        char device_cnt = 0;	// hwasung device detect counter        
	   	
        mUsbManager = (UsbManager)getSystemService(Context.USB_SERVICE);

	        
        HashMap<String, UsbDevice> deviceList = mUsbManager.getDeviceList();
	        
        Iterator<UsbDevice> deviceIterator = deviceList.values().iterator();

	        
        while(deviceIterator.hasNext()){ 
            UsbDevice device = deviceIterator.next();
			String mVendorId = String.valueOf(device.getVendorId());

            boolean b;
            b = Pattern.matches(HWASUNG_VENDOR_ID,mVendorId);
            if( b == true ){
                mDevice = device;
                device_cnt++;
                break;
            }
            // no hwasung device or disconnected
            else{
         		device_cnt = 0;
             }
	            
        }        

        if(device_cnt == 0) {
        	Title = "USB Connection";
     		Message = "Can not find Hwasung USB Device!";
            showDialog(Title, Message);
            return 0;
        }
       	UsbInterface  intf = mDevice.getInterface(0);
       	// endpoint type BULK
        UsbEndpoint ep = intf.getEndpoint(0);
	        
        if (ep.getType() != UsbConstants.USB_ENDPOINT_XFER_BULK) {
        	Log.e(TAG, "endpoint is not BULK type");
        	return 0;
        }

        mEndpointBulk = ep;
	      	
        if (mDevice != null) {
        	UsbDeviceConnection connection = mUsbManager.openDevice(mDevice);
        	if (connection != null && connection.claimInterface(intf, true)) {
                mConnection = connection;	// USB OPEN SUCCESS
            }
        }
        return device_cnt;
	       
    }

	    
	    
/*
 * *********************************************************************************
 *  Note!
 *  Do not edit this Method.
 *  You should only use call this Method.
 *
 * *********************************************************************************
 */
    private void sendCommand(UsbDevice device,int mIntBuf[],int mDataCnt) {

    	int mRet;
		  	
	  	if (mConnection != null) {
    		UsbInterface intf = device.getInterface(0);
    		UsbEndpoint ep = intf.getEndpoint(0);
	            	
    		byte[] mByteBuf = new byte[mDataCnt];
    		int i;
			mConnection.claimInterface(intf, true)
			;
    		// convert integer to byte
    		mByteBuf = new byte[mDataCnt];
	    		
    		for( i=0; i < mDataCnt ; i++) {
   				mByteBuf[i] = (byte) mIntBuf[i];
    		}
   		 	mRet = mConnection.bulkTransfer(ep, mByteBuf, mDataCnt, 0);

	  	}
	    	
    }
	
	
	
	// show Each Dialog
	public void showDialog(String Title,String Message){
	
		new AlertDialog.Builder(this)
		
        .setIcon(R.drawable.ic_launcher)
    	.setTitle(Title)
		.setMessage(Message)
	    .setPositiveButton("OK", null).show();

	}
	
	
	
}