package sample.hw_android_sdk_v100;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.AssetManager;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

// hwasung

public class MainActivity extends Activity {

	private static final String TAG = "MenuActivity";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		// save hwasung sample image file
		saveImageFile();
	}

	@Override
	public void onPause() {

		super.onPause();
	}
	@Override
	public void onResume() {

		super.onResume();
	}
	
	
	// USB Button
	public void onClick_USB_MAIN1( View v) {
        // show UsbMenuActivity
		Intent mIntent = new Intent(this,UsbMenuActivity.class);
        startActivityFromChild(this,mIntent,0);
	}

	
	// Wifi Button
	public void onClick_Wifi_MAIN1( View v) {
		Intent mIntent = new Intent(this,WifiActivity.class);
		startActivityFromChild(this,mIntent,0);

	}

	// Bluetooth Button
	public void onClick_Bl_MAIN1( View v) 
	{

			}

		@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		
		return true;
	}

/*
* *********************************************************************************
*  save hwasung sample image to file.
*
* *********************************************************************************
*/	
	public void saveImageFile(){
		
		String TAG = "Image File copying";
		AssetManager mAssetManager;
		String mPath;
		int i;
		
		String[] mFileList = null;
		File mFile = null;
		byte mFileCnt = 0;
		
	    // already there are sample 5 files then not save image file
		mFile  = new File(Environment.getExternalStorageDirectory().getPath()+"/hw_image/bicycle.bmp");
		if(mFile.isFile()) {
			mFileCnt++;
		}
		mFile  = new File(Environment.getExternalStorageDirectory().getPath()+"/hw_image/card.png");
		if(mFile.isFile()) {
			mFileCnt++;
		}
		mFile  = new File(Environment.getExternalStorageDirectory().getPath()+"/hw_image/namdaemoon.gif");
		if(mFile.isFile()) {
			mFileCnt++;
		}
		mFile  = new File(Environment.getExternalStorageDirectory().getPath()+"/hw_image/pizza.png");
		if(mFile.isFile()) {
			mFileCnt++;
		}
		mFile  = new File(Environment.getExternalStorageDirectory().getPath()+"/hw_image/graylogo.bmp");
		if(mFile.isFile()) {
			mFileCnt++;
		}
		

		if (mFileCnt >= 5 ) return;		// not save 
	
		// sample image files save
		mAssetManager = getAssets();
		mPath = "hw_image";
		try {
			mFileList = mAssetManager.list(mPath);
			mFile = new File(Environment.getExternalStorageDirectory().getPath() + mPath);
			if(!mFile.isDirectory()){
				mFile.mkdirs();
			}
		}
		catch (IOException e) {
			Log.e(TAG, e.getMessage(),e);
		}

		
		for(i=0;i<mFileList.length;i++) {
			InputStream mIn = null;
			OutputStream mOut = null;
			try {
				mIn = mAssetManager.open(mPath + "/" + mFileList[i]);
				mOut = new FileOutputStream(mFile.getPath() + "/" + mFileList[i]);
				// copying file
				byte[] mByteBuf = new byte[1024];
				int mCnt;
				while((mCnt = mIn.read(mByteBuf)) != -1) {
					mOut.write(mByteBuf, 0, mCnt);
				}
				mIn.close();
				mIn = null;
				mOut.flush();
				mOut.close();
				mOut = null;
			}
			catch (IOException e) {
				Log.e(TAG, e.getMessage(),e);
			}
		}
		
	}
	
	// show Each Dialog
	public void showDialog(String Title,String Message){
	
		new AlertDialog.Builder(this)
		.setIcon(R.drawable.ic_launcher)
    	.setTitle(Title)
		.setMessage(Message)
		.setPositiveButton("OK",null).show();

	}
	
	// key event    
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event)
    {

   	
   	if( keyCode == KeyEvent.KEYCODE_BACK )
     {
      new AlertDialog.Builder(this)
      .setIcon(R.drawable.ic_launcher)
      .setTitle("Quit")
      .setMessage("End Program?")
      .setPositiveButton("Yes", new DialogInterface.OnClickListener()
      {
        @Override
        public void onClick( DialogInterface dialog, int which )
        {
        	finish();
        }
      }).setNegativeButton( "Cacel", null ).show(); 
     
      return true;
     }
     
     return super.onKeyDown(keyCode, event);
    }	
	
	
	
}


