package sample.hw_android_sdk_v100;

import android.app.Activity;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.hardware.usb.UsbConstants;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbEndpoint;
import android.hardware.usb.UsbInterface;
import android.hardware.usb.UsbManager;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import java.nio.charset.Charset;
import java.util.HashMap;
import java.util.Iterator;
import java.util.regex.Pattern;

public class UsbMenuActivity extends Activity {

	
	private static final String TAG = "UsbMenuActivity";
	Thread statusThread;
	TextView status,count;
	boolean statusloop;
	byte[] readBuffer;
	int readBufferPosition;
	int prt_count;
	PendingIntent permissionIntent;

    private UsbManager mUsbManager;
    private UsbDevice mDevice;
    private UsbDeviceConnection mConnection;
    private UsbEndpoint mEndpointBulk;	
	// Intent
    private static final String ACTION_USB_PERMISSION = "com.android.example.USB_PERMISSION";
    // hwasung vendor id string
    private static final String HWASUNG_VENDOR_ID = "6";
	private static final int MAX_IMAGE_LINE = 24;	// NOTE! do not edit!

	// printer commands
    private static final byte CMD_DLE = 0x10;
    private static final byte CMD_ESC = 0x1b;
    private static final byte CMD_GS = 0x1d;
    private static final byte CMD_FS = 0x1c;

    
	@Override
    public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.usb_menu);
		mUsbManager = (UsbManager) getSystemService(Context.USB_SERVICE);
		Button logo_test = (Button) findViewById(R.id.logo_test_bt);
		status = (TextView)findViewById(R.id.stat_tv );
		permissionIntent = PendingIntent.getBroadcast(this, 0, new Intent(ACTION_USB_PERMISSION), 0);
		IntentFilter filter = new IntentFilter(ACTION_USB_PERMISSION);
		registerReceiver(usbReceiver, filter);
		setDevice();
		mUsbManager.requestPermission(mDevice, permissionIntent);
	}
	private final BroadcastReceiver usbReceiver = new BroadcastReceiver() {

		public void onReceive(Context context, Intent intent) {
			String action = intent.getAction();
			if (ACTION_USB_PERMISSION.equals(action)) {
				synchronized (this) {
					UsbDevice device = (UsbDevice)intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);

					if (intent.getBooleanExtra(UsbManager.EXTRA_PERMISSION_GRANTED, false)) {
						if(device != null){
							//call method to set up device communication
						}
					}
					else {
						Log.d(TAG, "permission denied for device " + device);
					}
				}
			}
		}
	};

	@Override
	public void onPause() {

		super.onPause();
	}
	@Override
	public void onResume() {

		super.onResume();
	}
	public void status_thread()
	{
		final Handler handler = new Handler();
		statusloop = true;

		statusThread = new Thread(new Runnable()
		{

			@Override
			public void run()
			{

				while(statusloop)
				{
					final int[] mIntBuf,mIntBuf3;
					int mDataCnt;
					final char device_cnt;

					device_cnt = setDevice();
					try {
						if(device_cnt != 0 ) {
							mIntBuf = new int[6];
							mIntBuf3 = new int[1];

							mIntBuf[0] = (byte) 0x10;
							mIntBuf[1] = (byte) 0xAA;
							mIntBuf[2] = (byte) 0x55;
							mIntBuf[3] = (byte) 0x80;
							mIntBuf[4] = (byte) 0x54;
							mIntBuf[5] = (byte) 0xAB;
							mDataCnt = 6;
							// call send data
							sendCommand(mDevice, mIntBuf, mDataCnt);
							Thread.sleep(1);
							receiveCommand(mDevice, mIntBuf3);
							handler.post(new Runnable()
							{
								public void run()
								{
									status.setText("Status(Dec) : "+ mIntBuf3[0]);
								}
							});
							//Log.d("status",""+Integer.toHexString(mIntBuf3[0]));
						}else{
							statusloop = false;
						}

						Thread.sleep(500);

					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();

					}
				}
			}
		});
		statusThread.start();
	}
	
    
    public void onClick_usb_text1(View v) {
    	char device_cnt;
    	byte mByteBuf[];
    	int mIntBuf[];
    	int mDataCnt;
    	String mStr,mStr2;
    	
    	int i,j;

    	
    	mStr = 	"   Hwasung System\n" +
    			"   Unit 604 Bldg B Digital Empire,\n" +
    			"   Kwanyang 906-4,Dongan,Anyang City,\n" +
    			"   Gyeonggi-Do 431-060,S.Korea\n" +
    			"                  TEL.82-31-8086-7550\n" +
    			"                  FAX.82-31-8086-7555\n" +
    			"\n" +
    			"  Price       Q'ty       Item\n" +
    			"------------------------------------\n" +
    			"  EUR1.50       1        Coke\n" +
    			"  EUR2.99       1        T-Shirts\n" +
    			"  EUR6.50      24        Corn Chips\n" +
    			"  EUR2.68       3        KFC\n" +
    			"  EUR3.66       4        Button\n" +
    			"-------------------------------------\n" ;
    	mStr2 =	" Total amount: EUR16.83\n\n" ;
  
    	
    	mDataCnt = mStr.length();
    	mIntBuf = new int[mDataCnt];
     	
    	// set Hwasung System usb device 
        device_cnt = setDevice();
 		// printer connected
        if(device_cnt != 0 ) {
        	
        	// get byte data from string
        	mByteBuf = mStr.getBytes();
        	// set data to integer buffer
        	for(i=0;i<mDataCnt;i++) {
        		mIntBuf[i] = (int) mByteBuf[i];
        	}
        	
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);

        	// vertical double size print
        	mIntBuf[0] = CMD_GS;
        	mIntBuf[1] = '!';
        	mIntBuf[2] = 0x01;
        	mDataCnt = 3;
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);
        	
        	// print str2
        	mDataCnt = mStr2.length();
        	mByteBuf = mStr2.getBytes();
        	// set data to integer buffer
        	for(i=0;i<mDataCnt;i++) {
        		mIntBuf[i] = (int) mByteBuf[i];
        	}
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);

        	// clear double size
        	mIntBuf[0] = CMD_GS;
        	mIntBuf[1] = '!';
        	mIntBuf[2] = 0x00;
        	mDataCnt = 3;
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);
        	
        	// barcode sample
        	// centering print position
        	mIntBuf[0] = CMD_ESC;
        	mIntBuf[1] = 0x61;
        	mIntBuf[2] = 0x01;
        	mDataCnt = 3;
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);

        	// barcod height
           	mIntBuf[0] = CMD_GS;
        	mIntBuf[1] = 'h';
        	mIntBuf[2] = 0x80;
        	mDataCnt = 3;
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);
     	
        	// barcode command
           	mIntBuf[0] = CMD_GS;
        	mIntBuf[1] = 0x6b;
        	mIntBuf[2] = 0x06;
        	mDataCnt = 3;
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);
        	
        	mStr = "1234567890ABCD";
        	mDataCnt = mStr.length();
        	// get byte data from string
        	mByteBuf = mStr.getBytes();
     	
        	// set data to integer buffer
        	for(i=0;i<mDataCnt;i++) {
        		mIntBuf[i] = (int) mByteBuf[i];
        	}
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);
        	
        	mIntBuf[0] = 0x00;	// barcode data end
        	mIntBuf[1]  = 0x0a;	// line feed
        	mDataCnt = 2;
        	sendCommand(mDevice,mIntBuf,mDataCnt);
 
        	// clear centering
           	mIntBuf[0] = CMD_ESC;
        	mIntBuf[1] = 0x61;
        	mIntBuf[2] = 0x00;
        	mDataCnt = 3;
        	sendCommand(mDevice,mIntBuf,mDataCnt);
      	
        	// feeding
        	mIntBuf[0] = 0x0a;
        	mIntBuf[1] = 0x0a;
        	mIntBuf[2] = 0x0a;
        	mIntBuf[3] = 0x0a;
        	mIntBuf[4] = 0x0a;
        	mDataCnt = 5;
        	sendCommand(mDevice,mIntBuf,mDataCnt);
        	
        	// full cutting
        	mIntBuf[0] = CMD_ESC;
        	mIntBuf[1] = 0x69;
        	mDataCnt = 2;
        	sendCommand(mDevice,mIntBuf,mDataCnt);

        }
            	
    }

    public void onClick_usb_text2(View v) {
 		char device_cnt;
 		String mStr,mStr2;
    	int mIntBuf[] ;
    	int mDataCnt,i;
		byte mByteBuf[];
    	
 		mStr = "  화성시스템(주)\n" +
 			   "  경기도 안양시 동안구 관양동 906-4\n" +
 			   "  디지털엠파이 B동 604호\n" +
 			   "  TEL.031-8086-7550\n" +
 			   "  FAX.031-8086-7555\n\n" +
 			   "  품명           수량          가격\n" +
 			   "------------------------------------\n" +
 			   "  코카콜라         1           \\700\n" +
 			   "  티셔츠           1         \\7,000\n" +
 			   "  콘칩            25        \\15,000\n" +
 			   "  양념치킨         1         \\6,500\n" +
 			   "  생수             1         \\5,300\n" +
 			   "------------------------------------\n" ;
 		mStr2 ="  합계금액: \\34,500원\n\n";  
 		
    	// set Hwasung Syatem usb device
    	device_cnt = setDevice();
        
        if(device_cnt != 0 ) {
        	
    		// string1 convert hangul character set
    		mByteBuf = mStr.getBytes(Charset.forName("EUC-KR"));
    		mDataCnt = mByteBuf.length;
        	mIntBuf = new int[mDataCnt];

        	// set data to integer buffer
        	for(i=0;i<mDataCnt;i++) {
        		mIntBuf[i] = (int) mByteBuf[i];
        	}
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);

        	// vertical double size print
        	mIntBuf[0] = CMD_GS;
        	mIntBuf[1] = '!';
        	mIntBuf[2] = 0x01;
        	mDataCnt = 3;
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);

    		// string2 convert hangul character set
    		mByteBuf = mStr2.getBytes(Charset.forName("EUC-KR"));
       		mDataCnt = mByteBuf.length;
        	// set data to integer buffer
        	for(i=0;i<mDataCnt;i++) {
        		mIntBuf[i] = (int) mByteBuf[i];
        	}
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);

        	// clear double size
        	mIntBuf[0] = CMD_GS;
        	mIntBuf[1] = '!';
        	mIntBuf[2] = 0x00;
        	mDataCnt = 3;
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);
        	
        	// barcode sample
        	// centering print position
        	mIntBuf[0] = CMD_ESC;
        	mIntBuf[1] = 0x61;
        	mIntBuf[2] = 0x01;
        	mDataCnt = 3;
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);

        	// barcod height
           	mIntBuf[0] = CMD_GS;
        	mIntBuf[1] = 'h';
        	mIntBuf[2] = 0x80;
        	mDataCnt = 3;
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);
     	
        	// barcode command
           	mIntBuf[0] = CMD_GS;
        	mIntBuf[1] = 0x6b;
        	mIntBuf[2] = 0x06;
        	mDataCnt = 3;
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);
        	
        	mStr = "1234567890ABCD";
        	mDataCnt = mStr.length();
        	// get byte data from string
        	mByteBuf = mStr.getBytes();
     	
        	// set data to integer buffer
        	for(i=0;i<mDataCnt;i++) {
        		mIntBuf[i] = (int) mByteBuf[i];
        	}
        	// call send data
        	sendCommand(mDevice,mIntBuf,mDataCnt);
        	
        	mIntBuf[0] = 0x00;	// barcode data end
        	mIntBuf[1]  = 0x0a;	// line feed
        	mDataCnt = 2;
        	sendCommand(mDevice,mIntBuf,mDataCnt);
 
        	// clear centering
           	mIntBuf[0] = CMD_ESC;
        	mIntBuf[1] = 0x61;
        	mIntBuf[2] = 0x00;
        	mDataCnt = 3;
        	sendCommand(mDevice,mIntBuf,mDataCnt);

        	// string3
			mStr = "  항상 저희 제품을 애용해 주셔서 감사합니다!\n" +
			       "  안녕히가십시오!\n" ;
		     
    		mByteBuf = mStr.getBytes(Charset.forName("EUC-KR"));
       		mDataCnt = mByteBuf.length;
       		// set data to integer buffer
        	for(i=0;i<mDataCnt;i++) {
        		mIntBuf[i] = (int) mByteBuf[i];
        	}
        	sendCommand(mDevice,mIntBuf,mDataCnt);
         	
        	// feeding
        	mIntBuf[0] = 0x0a;
        	mIntBuf[1] = 0x0a;
        	mIntBuf[2] = 0x0a;
        	mIntBuf[3] = 0x0a;
        	mIntBuf[4] = 0x0a;
        	mDataCnt = 5;
        	sendCommand(mDevice,mIntBuf,mDataCnt);
        	
        	// full cutting
        	mIntBuf[0] = CMD_ESC;
        	mIntBuf[1] = 0x69;
        	mDataCnt = 2;
        	sendCommand(mDevice,mIntBuf,mDataCnt);

        }

        
     }
    
    public void onClick_usb_bitmap1(View v) {
  		char device_cnt;
  		byte Buf[] = new byte[255];

        // show UsbMenuActivity
		Intent mIntent = new Intent(this,ImagePrintActivity.class);
        startActivityFromChild(this,mIntent,0);
 		
    }

    public void onClick_usb_read1(View v) {
 		String Title;
 		String Message;
 		
    	char device_cnt;
    	int[] mIntBuf ;
    	int[] mIntBuf3 = new int[12];
  		int mDataCnt,i,mRet;
  		
         device_cnt = setDevice();

         if(device_cnt != 0 ) {

        	mDataCnt = 6;
        	mIntBuf = new int[mDataCnt];

        	mIntBuf[0] = 0x10;
        	mIntBuf[1] = 0xAA;
        	mIntBuf[2] = 0x55;
        	mIntBuf[3] = 0x80;
        	mIntBuf[4] = 0x54;
        	mIntBuf[5] = 0xAB;

        	sendCommand(mDevice, mIntBuf,mDataCnt);

        	receiveCommand(mDevice, mIntBuf3);

        	// display status value of printer

     		Log.d(TAG, "status : "+mIntBuf3[0]);
     		status.setText("status : " + mIntBuf3[0]);
     		
         }
  		
    }
    
/*
 * *********************************************************************************
 *  Note!
 *  Do not edit this Method.
 *  You should only use call this Method.
 *
 * *********************************************************************************
 */   
    private char setDevice() {
    
 		String Title;
 		String Message;
 		String mDeviceNameStr;
 		UsbDevice mDeviceName;
        char device_cnt = 0;	// hwasung device detect counter
   	
        mUsbManager = (UsbManager)getSystemService(Context.USB_SERVICE);

        
        HashMap<String, UsbDevice> deviceList = mUsbManager.getDeviceList();
        
        Iterator<UsbDevice> deviceIterator = deviceList.values().iterator();

        
        while(deviceIterator.hasNext()){ 
            UsbDevice device = deviceIterator.next();
            String mVendorId = String.valueOf(device.getVendorId());

            boolean b;
            b = Pattern.matches(HWASUNG_VENDOR_ID,mVendorId);
            if( b == true ){
                mDevice = device;
                device_cnt++;
                break;
            }
            // no hwasung device or disconnected
            else{
         		device_cnt = 0;
             }
            
        }        

        if(device_cnt == 0) {
//        	Title = "USB Connection";
//     		Message = "Can not find Hwasung USB Device!";
//            showDialog(Title, Message);

            return 0;
        }
       	UsbInterface  intf = mDevice.getInterface(0);
       	// endpoint type BULK
        UsbEndpoint ep = intf.getEndpoint(0);
        
        if (ep.getType() != UsbConstants.USB_ENDPOINT_XFER_BULK) {
        	Log.e(TAG, "endpoint is not BULK type");
        	return 0;
        }

        mEndpointBulk = ep;
      	
        if (mDevice != null) {
        	UsbDeviceConnection connection = mUsbManager.openDevice(mDevice);
        	if (connection != null && connection.claimInterface(intf, true)) {
                mConnection = connection;	// USB OPEN SUCCESS
            }
        }
        return device_cnt;
       
    }

    
    
/*
 * *********************************************************************************
 *  Note!
 *  Do not edit this Method.
 *  You should only use call this Method.
 *
 * *********************************************************************************
 */
    private void sendCommand(UsbDevice device,int mIntBuf[],int mDataCnt) {

    	int mRet;
	  	
	  	if (mConnection != null) {
    		UsbInterface intf = device.getInterface(0);
    		UsbEndpoint ep = intf.getEndpoint(0);
            	
    		byte[] mByteBuf = new byte[mDataCnt];
    		int i;
    		
    		// convert integer to byte
    		mByteBuf = new byte[mDataCnt];
    		
    		for( i=0; i < mDataCnt ; i++) {
   				mByteBuf[i] = (byte) mIntBuf[i];
    		}
   		 	mRet = mConnection.bulkTransfer(ep, mByteBuf, mDataCnt, 5000);
			if (mRet == -1)Log.d("send command fail", ""+mRet);
	  	}
    	
    }
/*
 * *********************************************************************************
 *  Note!
 *  Do not edit this Method.
 *  You should only use call this Method.
 *
 * *********************************************************************************
 */
    private void receiveCommand(UsbDevice device,int mIntBuf[]) {
    	String Title;
   		String Message;

    	int mRet,i;
	  	
	  	if (mConnection != null) {

	  		UsbInterface intf = device.getInterface(0);
    		// receive BULK-IN endpoint6(mAddress:0x86)
	  		UsbEndpoint ep = intf.getEndpoint(2);  //엡손 호환 테스트용 수정됨	
  		
    		byte[] mByteBuf = new byte[1];
  
   		 	// 1byte read, time out 1second
    		mRet = mConnection.bulkTransfer( ep, mByteBuf, 1, 5000);
    		if(mRet == -1) {
    			Log.d("status fail", "수신 실패");
				Log.d("receive command ", ""+mRet);
			}
    		// set 1byte status data to integer buffer and return
    		mIntBuf[0] = (int) mByteBuf[0];



		}
    	
    }

/*	
// broadcast receiver, do not use this Method	
	private final BroadcastReceiver mUsbReceiver = new BroadcastReceiver()
	{
		public void onReceive(Context context, Intent intent)
		{
			String action = intent.getAction();
			if (ACTION_USB_PERMISSION.equals(action))
			{
				synchronized (this)
				{
					UsbDevice device = (UsbDevice) intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);
					if (intent.getBooleanExtra(UsbManager.EXTRA_PERMISSION_GRANTED, false))
					{
						if (device != null)
						{
							// call method to set up device communication
							//setDevice(device);
						}
					}
					else
					{
						Log.d(TAG, "permission denied for device " + device);
					}
				}
			}
			if (UsbManager.ACTION_USB_DEVICE_DETACHED.equals(action)) 
			{
	            UsbDevice device = (UsbDevice)intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);
	            if (device != null) 
	            {
	            	// call method that cleans up and closes communication with the device
	                UsbInterface intf = device.getInterface(0);
	            	mConnection.releaseInterface(intf);
	            	mConnection.close();
	            }
	        }
		}
	};
*/	

	
	
	
}	// UsbMenuActivity End
