package sample.hw_android_sdk_v100;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.StrictMode;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;

public class WifiActivity extends Activity {
    private Handler mHandler;
    private Socket socket;
    private BufferedReader networkReader;
    private BufferedOutputStream networkWriter;
    private String ip ;
    private int port ;
    private static final byte CMD_ESC = 0x1b;
    private static final byte CMD_GS = 0x1d;
    private static final byte CMD_FS = 0x1c;

    @Override
    protected void onStop() {
        super.onStop();

        try {
            if(!(socket == null)){
                socket.close();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.wifi_menu);
        mHandler = new Handler();
        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);


        final EditText ip_addr = findViewById(R.id.wifi_ip);
        final EditText port_et = findViewById(R.id.wifi_port);
        Button connect = findViewById(R.id.wifi_connect);
        final EditText tv = findViewById(R.id.wifi_sendtxt);
        Button receipt_kr = findViewById(R.id.wifi_receiptkr);
        receipt_kr.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String mStr,mStr2;
                byte[] mbyteBuf ;

                try{
                    mStr = "  화성시스템(주)\n" +
                            "  경기도 안양시 동안구 관양동 906-4\n" +
                            "  디지털엠파이어 B동 604호\n" +
                            "  TEL.031-8086-7550\n" +
                            "  FAX.031-8086-7555\n\n" +
                            "  품명           수량          가격\n" +
                            "------------------------------------\n" +
                            "  코카콜라         1           \\700\n" +
                            "  티셔츠           1         \\7,000\n" +
                            "  콘칩            25        \\15,000\n" +
                            "  양념치킨         1         \\6,500\n" +
                            "  생수             1         \\5,300\n" +
                            "------------------------------------\n" ;
                    mStr2 ="  합계금액: \\34,500원\n\n";
                    byte[] euckr = mStr.getBytes("euc-kr");

                    networkWriter.write(euckr);
                    euckr = mStr2.getBytes("euc-kr");

                    mbyteBuf = new byte[3];
                    // vertical double size print
                    mbyteBuf[0] = CMD_GS;
                    mbyteBuf[1] = '!';
                    mbyteBuf[2] = 0x01;
                    // call send data
                    networkWriter.write(mbyteBuf);

                    // print str2
                    networkWriter.write(euckr);

                    // clear double size
                    mbyteBuf[0] = CMD_GS;
                    mbyteBuf[1] = '!';
                    mbyteBuf[2] = 0x00;
                    // call send data
                    networkWriter.write(mbyteBuf);

                    // barcode sample
                    // centering print position
                    mbyteBuf[0] = CMD_ESC;
                    mbyteBuf[1] = 0x61;
                    mbyteBuf[2] = 0x01;
                    // call send data
                    networkWriter.write(mbyteBuf);

                    // barcode height
                    mbyteBuf[0] = CMD_GS;
                    mbyteBuf[1] = 'h';
                    mbyteBuf[2] = (byte)0x80;
                    // call send data
                    networkWriter.write(mbyteBuf);

                    // barcode command
                    mbyteBuf[0] = CMD_GS;
                    mbyteBuf[1] = 0x6b;
                    mbyteBuf[2] = 0x06;
                    // call send data
                    networkWriter.write(mbyteBuf);

                    mStr = "1234567890ABCD";
                    // call send data
                    networkWriter.write(mStr.getBytes());

                    mbyteBuf = new byte[2];
                    mbyteBuf[0] = 0x00;	// barcode data end
                    mbyteBuf[1]  = 0x0a;	// line feed
                    networkWriter.write(mbyteBuf);

                    mbyteBuf = new byte[3];
                    // clear centering
                    mbyteBuf[0] = CMD_ESC;
                    mbyteBuf[1] = 0x61;
                    mbyteBuf[2] = 0x00;
                    networkWriter.write(mbyteBuf);

                    mStr = "  항상 저희 제품을 애용해 주셔서 감사합니다!\n" +
                            "  안녕히가십시오!\n" ;
                    euckr = mStr.getBytes("euc-kr");
                    networkWriter.write(euckr);

                    mbyteBuf = new byte[5];
                    // feeding
                    mbyteBuf[0] = 0x0a;
                    mbyteBuf[1] = 0x0a;
                    mbyteBuf[2] = 0x0a;
                    mbyteBuf[3] = 0x0a;
                    mbyteBuf[4] = 0x0a;
                    networkWriter.write(mbyteBuf);

                    // full cutting
                    mbyteBuf[0] = CMD_ESC;
                    mbyteBuf[1] = 0x69;
                    networkWriter.write(mbyteBuf);
                    networkWriter.flush();
                }catch (IOException e){
                }
            }
        });

        connect.setOnClickListener(new View.OnClickListener() {

            public void onClick(View v) {
                ip = ip_addr.getText().toString();
                port = Integer.valueOf(port_et.getText().toString());
                try{
                    setSocket(ip,port);
                }catch (IOException e){
                    Log.d("io_error",""+e);
                }
            }
        });
        Button disconnect = findViewById(R.id.wifi_disconnect );
        disconnect.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                try {
                    socket.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
        Button testbt = findViewById(R.id.test_bt);
        testbt.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int status;

                try{
                    byte[] mbyteBuf;

                    mbyteBuf = new byte[6];

                    mbyteBuf[0] = (byte)0x10;
                    mbyteBuf[1] = (byte)0xAA;
                    mbyteBuf[2] = (byte)0x55;
                    mbyteBuf[3] = (byte)0x80;
                    mbyteBuf[4] = (byte)0x54;
                    mbyteBuf[5] = (byte)0xAB;

                    networkWriter.write(mbyteBuf);
                    networkWriter.flush();
                    try{
                        Thread.sleep(100);
                        status = networkReader.read();
                        Toast.makeText(WifiActivity.this,"Status : " + status,Toast.LENGTH_SHORT).show();
                        Log.d("thread receive",""+ status);

                    }catch(InterruptedException e){
                        Log.d("sleep error","sleep error " + e);
                    }

                }catch(IOException e){
                    Log.d("ioexception","" + e);

                }

            }
        });
        Button receipt_en = findViewById(R.id.wifi_receipten );
        receipt_en.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                try
                {
                    String mStr,mStr2;
                    byte[] mbyteBuf ;
                    mStr = 	"   Hwasung System\n" +
                            "   Unit 604 Bldg B Digital Empire,\n" +
                            "   Kwanyang 906-4,Dongan,Anyang City,\n" +
                            "   Gyeonggi-Do 431-060,S.Korea\n" +
                            "                  TEL.82-31-8086-7550\n" +
                            "                  FAX.82-31-8086-7555\n" +
                            "\n" +
                            "  Price       Q'ty       Item\n" +
                            "------------------------------------\n" +
                            "  EUR1.50       1        Coke\n" +
                            "  EUR2.99       1        T-Shirts\n" +
                            "  EUR6.50      24        Corn Chips\n" +
                            "  EUR2.68       3        KFC\n" +
                            "  EUR3.66       4        Button\n" +
                            "-------------------------------------\n" ;
                    mStr2 =	" Total amount: EUR16.83\n\n" ;

                    byte[] euckr = mStr.getBytes();
                    networkWriter.write(euckr);

                    mbyteBuf = new byte[3];
                    // vertical double size print
                    mbyteBuf[0] = CMD_GS;
                    mbyteBuf[1] = '!';
                    mbyteBuf[2] = 0x01;
                    // call send data
                    networkWriter.write(mbyteBuf);

                    // print str2
                    euckr = mStr2.getBytes();
                    networkWriter.write(euckr);

                    // clear double size
                    mbyteBuf[0] = CMD_GS;
                    mbyteBuf[1] = '!';
                    mbyteBuf[2] = 0x00;
                    // call send data
                    networkWriter.write(mbyteBuf);

                    // barcode sample
                    // centering print position
                    mbyteBuf[0] = CMD_ESC;
                    mbyteBuf[1] = 0x61;
                    mbyteBuf[2] = 0x01;
                    // call send data
                    networkWriter.write(mbyteBuf);

                    // barcode height
                    mbyteBuf[0] = CMD_GS;
                    mbyteBuf[1] = 'h';
                    mbyteBuf[2] = (byte)0x80;
                    // call send data
                    networkWriter.write(mbyteBuf);

                    // barcode command
                    mbyteBuf[0] = CMD_GS;
                    mbyteBuf[1] = 0x6b;
                    mbyteBuf[2] = 0x06;
                    // call send data
                    networkWriter.write(mbyteBuf);

                    mStr = "1234567890ABCD";
                    // call send data
                    networkWriter.write(mStr.getBytes());

                    mbyteBuf = new byte[2];
                    mbyteBuf[0] = 0x00;	// barcode data end
                    mbyteBuf[1]  = 0x0a;	// line feed
                    networkWriter.write(mbyteBuf);

                    mbyteBuf = new byte[3];
                    // clear centering
                    mbyteBuf[0] = CMD_ESC;
                    mbyteBuf[1] = 0x61;
                    mbyteBuf[2] = 0x00;
                    networkWriter.write(mbyteBuf);

                    mbyteBuf = new byte[5];
                    // feeding
                    mbyteBuf[0] = 0x0a;
                    mbyteBuf[1] = 0x0a;
                    mbyteBuf[2] = 0x0a;
                    mbyteBuf[3] = 0x0a;
                    mbyteBuf[4] = 0x0a;
                    networkWriter.write(mbyteBuf);

                    // full cutting
                    mbyteBuf[0] = CMD_ESC;
                    mbyteBuf[1] = 0x69;
                    networkWriter.write(mbyteBuf);
                    networkWriter.flush();
                }
                catch (IOException e)
                {
                    Log.d("io_error",""+e);
                }
            }
        });

        Button send = findViewById(R.id.wifi_send);
        send.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String send_txt = tv.getText().toString();
                try{
                    networkWriter.write(send_txt.getBytes("euc-kr"));
                    networkWriter.write(0x0a);
                    networkWriter.flush();
                }catch (IOException e){
                    Log.d("io_error",""+e);
                }

            }
        });
        Button img_btn = findViewById(R.id.wifi_image);
        img_btn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                try{
                    socket.close();
                }catch (IOException e){
                    Log.d("io_error",""+e);
                }
                Intent mIntent = new Intent(WifiActivity.this,WifiImageActivity.class);
                startActivityFromChild(WifiActivity.this,mIntent,0);
            }
        });
    }

    public void setSocket(String ip, int port) throws IOException {
        try {
            socket = new Socket(ip, port);
            networkWriter = new BufferedOutputStream(new BufferedOutputStream(socket.getOutputStream()));
            networkReader = new BufferedReader(new InputStreamReader(socket.getInputStream()));

        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
