package sample.hw_android_sdk_v100;

import android.app.Activity;
import android.app.AlertDialog;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.os.Handler;
import android.os.StrictMode;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.SpinnerAdapter;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;


public class WifiImageActivity extends Activity implements OnItemSelectedListener {

	private static final String TAG = "image file printing";


    // printer commands
    private static final byte CMD_DLE = 0x10;
    private static final byte CMD_ESC = 0x1b;
    private static final byte CMD_GS = 0x1d;
    private static final byte CMD_FS = 0x1c;
    private static final byte CMD_SUB = 0x1a;
    private static final int MAX_IMAGE_LINE = 24;	// NOTE! do not edit!


	private Handler mHandler;

	private Socket socket;

	private BufferedReader networkReader;
	private BufferedOutputStream networkWriter;
	private int port;
	private String ip;
	private String html = "";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.image_print);
		StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
		StrictMode.setThreadPolicy(policy);
		Spinner mSpinner1 = (Spinner)findViewById(R.id.spinner1_item);
		SpinnerAdapter ad = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, new String[] {"Sample1","Sample2","Sample3","Sample4","Sample5"});
		mSpinner1.setAdapter(ad);
		mSpinner1.setOnItemSelectedListener(this);

		ip = "192.168.12.101";
		port = 9100;
		try{
			setSocket(ip,port);
		}catch (IOException e){

		}

	
	}

	public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
		
		ImageView mImageView;
		Bitmap bm;

		mImageView = (ImageView) findViewById(R.id.imageView);
		
		switch(arg2)
		{
		case 0:
			bm = BitmapFactory.decodeFile("/sdcard/hw_image/bicycle.bmp");
			mImageView.setImageBitmap(bm);
			break;
		case 1:
			bm = BitmapFactory.decodeFile("/sdcard/hw_image/card.png");
			mImageView.setImageBitmap(bm);
			break;
		case 2:
			bm = BitmapFactory.decodeFile("/sdcard/hw_image/namdaemoon.gif");
			mImageView.setImageBitmap(bm);
			break;
		case 3:
			bm = BitmapFactory.decodeFile("/sdcard/hw_image/pizza.png");
			mImageView.setImageBitmap(bm);
			break;
		case 4:
			bm = BitmapFactory.decodeFile("/sdcard/hw_image/graylogo.bmp");
			mImageView.setImageBitmap(bm);
			break;
		}
	}	
	
	
	public void onNothingSelected(AdapterView<?> arg0) {
		// none process
	}

/*
 * *********************************************************************************
 *  Note! Do not edit the MAX_IMAGE_LINE = 192
 *  You can edit this Method for image file printing.
 *
 * *********************************************************************************
 */   
	
	// print Button
	public void onClick_image_print1( View v) {

        byte[] mIntBuf, mIntBuf2;
        int i, j, k, byteOffset, bitToByte;
        int mDataCnt, prnLine, byteWidth;
        Bitmap bm;

        String Title;
        String Message;


        mIntBuf2 = new byte[128];
        int bmWidth, bmHeight;
        int x, y;
        int[] mPixels;
        byte rest = 0;    // multiple of 8?
        int blockCnt;    // row data block counter


        bm = BitmapFactory.decodeFile("/sdcard/hw_image/graylogo.bmp");


        Spinner mSpinner1 = (Spinner) findViewById(R.id.spinner1_item);

        switch (mSpinner1.getSelectedItemPosition()) {
            case 0:
                bm = BitmapFactory.decodeFile("/sdcard/hw_image/bicycle.bmp");
                break;
            case 1:
                bm = BitmapFactory.decodeFile("/sdcard/hw_image/card.png");
                break;
            case 2:
                bm = BitmapFactory.decodeFile("/sdcard/hw_image/namdaemoon.bmp");
                break;
            case 3:
                bm = BitmapFactory.decodeFile("/sdcard/hw_image/pizza.png");
                break;
            case 4:
                bm = BitmapFactory.decodeFile("/sdcard/hw_image/graylogo.bmp");
                break;
        }

        // get image data height
        bmHeight = bm.getHeight();
        // get image data width
        bmWidth = bm.getWidth();
        byteWidth = (bmWidth / 8);
        i = bmWidth % 8;
        if (i > 0) {
            byteWidth = (byteWidth + 1);
            rest = 1;
        }    // none multiple of 8


        // lower the print speed for smooth printing
        // print speed command 3byte
        mDataCnt = 3;
        mIntBuf2 = new byte[mDataCnt];
        mIntBuf2[0] = CMD_SUB;
        mIntBuf2[1] = 's';
        mIntBuf2[2] = 0x01;
        int cnt = 0;
        try {
            networkWriter.write(mIntBuf2);

            networkWriter.flush();
        } catch (IOException e) {
        }
        x = y = 0;
        mPixels = new int[bmWidth * MAX_IMAGE_LINE];        // max prnLine = 192
        mIntBuf = new byte[(byteWidth * MAX_IMAGE_LINE)];

        blockCnt = (bmHeight / MAX_IMAGE_LINE);
        if ((bmHeight % MAX_IMAGE_LINE) > 0) blockCnt += 1;

        for (k = 0; k < blockCnt; k++) {
            if (bmHeight >= MAX_IMAGE_LINE) {
                prnLine = MAX_IMAGE_LINE;
                bmHeight = bmHeight - prnLine;
            } else {
                prnLine = bmHeight;
            }

            // get pixel color data
            bm.getPixels(mPixels, 0, bmWidth, x, y, bmWidth, prnLine);

            j = 0;
            bitToByte = 0;
            int bit_p = 0;

            for (i = 0; i < (bmWidth * prnLine); i++) {
                switch (bit_p % 8) {
                    case 0:
                        if (mPixels[i] == 0xff000000) {
                            bitToByte |= 0x80;
                        }    // black
                        if (mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff) {
                            Title = "image data error(bit7)";
                            Message = "pixel value:" + Integer.toString(mPixels[i]);
                            showDialog(Title, Message);
                            return;
                        }
                        break;
                    case 1:
                        if (mPixels[i] == 0xff000000) {
                            bitToByte |= 0x40;
                        }    // black
                        if (mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff) {
                            Title = "image data error(bit6)";
                            Message = "pixel value:" + Integer.toString(mPixels[i]);
                            showDialog(Title, Message);
                            return;
                        }
                        break;
                    case 2:
                        if (mPixels[i] == 0xff000000) {
                            bitToByte |= 0x20;
                        }    // black
                        if (mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff) {
                            Title = "image data error(bit5)";
                            Message = "pixel value:" + Integer.toString(mPixels[i]);
                            showDialog(Title, Message);
                            return;
                        }
                        break;
                    case 3:
                        if (mPixels[i] == 0xff000000) {
                            bitToByte |= 0x10;
                        }    // black
                        if (mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff) {
                            Title = "image data error(bit4)";
                            Message = "pixel value:" + Integer.toString(mPixels[i]);
                            showDialog(Title, Message);
                            return;
                        }
                        break;
                    case 4:
                        if (mPixels[i] == 0xff000000) {
                            bitToByte |= 0x08;
                        }    // black
                        if (mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff) {
                            Title = "image data error(bit3)";
                            Message = "pixel value:" + Integer.toString(mPixels[i]);
                            showDialog(Title, Message);
                            return;
                        }
                        break;
                    case 5:
                        if (mPixels[i] == 0xff000000) {
                            bitToByte |= 0x04;
                        }    // black
                        if (mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff) {
                            Title = "image data error(bit2)";
                            Message = "pixel value:" + Integer.toString(mPixels[i]);
                            showDialog(Title, Message);
                            return;
                        }
                        break;
                    case 6:
                        if (mPixels[i] == 0xff000000) {
                            bitToByte |= 0x02;
                        }    // black
                        if (mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff) {
                            Title = "image data error(bit1)";
                            Message = "pixel value:" + Integer.toString(mPixels[i]);
                            showDialog(Title, Message);
                            return;
                        }

                        break;
                    case 7:
                        if (mPixels[i] == 0xff000000) {
                            bitToByte |= 0x01;
                        }    // black
                        if (mPixels[i] != 0xff000000 && mPixels[i] != 0xffffffff) {
                            Title = "image data error(bit0)";
                            Message = "pixel value:" + Integer.toString(mPixels[i]);
                            showDialog(Title, Message);
                            return;
                        }

                        break;
                }
                if ((bit_p % 8) == 7) {
                    mIntBuf[j] = (byte) bitToByte;
                    bitToByte = 0;
                    j++;
                }

                bit_p++;

                // last dot each line
                if ((i % bmWidth) == (bmWidth - 1)) {
                    if (rest == 1) {        // if none multiple of 8, last byte
                        mIntBuf[j] = (byte) bitToByte;
                        bitToByte = 0;
                        bit_p = 0;
                        j++;
                    }
                }

            }    // i end

            // send raster bitimage command 8byte
            mDataCnt = 8;
            mIntBuf2 = new byte[mDataCnt];
            mIntBuf2[0] = CMD_GS;
            mIntBuf2[1] = 'v';
            mIntBuf2[2] = '0';
            mIntBuf2[3] = 0x00;                // size normal
            mIntBuf2[4] = (byte) (byteWidth % 256);    // xL(LSB horizental number of data)
            mIntBuf2[5] = (byte) (byteWidth / 256);    // xH(MSB horizental number of data)
            mIntBuf2[6] = (byte) (prnLine % 256);    // yL(LSB vertical number of line)
            mIntBuf2[7] = (byte) (prnLine / 256);    // yH(MSB vertical number of line)

            try {
            networkWriter.write(mIntBuf2);
            networkWriter.flush();
            }catch (IOException e){

            }
            mDataCnt = byteWidth * prnLine;
            try{
                networkWriter.write(mIntBuf,0,mDataCnt);
            	networkWriter.flush();
            }catch (IOException e){
            	Log.d("ioex : ",e.toString());
            }
            y += prnLine;
        }
        mDataCnt = 3;
        mIntBuf2 = new byte[mDataCnt];
        mIntBuf2[0] = 0x0a;
        mIntBuf2[1] = 0x0a;
        mIntBuf2[2] = 0x0a;
        try {
            networkWriter.write(mIntBuf2);
            networkWriter.write(mIntBuf2);
            networkWriter.flush();
        } catch (IOException e) {
        }
        mDataCnt = 2;
        mIntBuf2 = new byte[mDataCnt];
        mIntBuf2[0] = 0x1b;
        mIntBuf2[1] = 0x69;
        try {
            networkWriter.write(mIntBuf2);
            networkWriter.flush();
        } catch (IOException e) {
        }

	}	// k end


/*
 * *********************************************************************************
 *  Note!
 *  Do not edit this Method.
 *  You should only use call this Method.
 *
 * *********************************************************************************
 */   

	    
	    
/*
 * *********************************************************************************
 *  Note!
 *  Do not edit this Method.
 *  You should only use call this Method.
 *
 * *********************************************************************************
 */





@Override
protected void onStop() {
	super.onStop();

        try {
            if(!(socket == null)){
                socket.close();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
}

	public void setSocket(String ip, int port) throws IOException {

		try {
			socket = new Socket(ip, port);
			networkWriter = new BufferedOutputStream(new BufferedOutputStream(socket.getOutputStream()));
			networkReader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
		} catch (IOException e) {
			System.out.println(e);
			e.printStackTrace();
		}

	}


	
	// show Each Dialog
	public void showDialog(String Title, String Message){
	
		new AlertDialog.Builder(this)
		
        .setIcon(R.drawable.ic_launcher)
    	.setTitle(Title)
		.setMessage(Message)
	    .setPositiveButton("OK", null).show();

	}

	
	
}